#!/usr/bin/perl
##############################################################
#
#   Shorewall Accounting Statistics for MRTG
#   http://www.tylerdavis.com/code/
#
#   This script is under the GPL (GENERAL PUBLIC LICENSE)
#   http://www.gnu.org/copyleft/gpl.html
#
#   (C) 2004 by Tyler Davis <me@tylerdavis.com>
#
#############################################################
# CONFIGURATION
#############################################################
# path to shorewall binary
$shorewall = "/sbin/shorewall";
# path to uptime binary
$uptime    = "/usr/bin/uptime";
# path to hostname or simply enter hostname
$hostname  = "/bin/hostname";
#############################################################
# END OF CONFIGURATION
#############################################################
	
	# see if any counters were defined
	if (!@ARGV) {
		print "\nShorewall Accounting Statistics for MRTG\n";
		print "Version v0.0.1\n";
		print "http://www.tylerdavis.com/code/\n\n";
		print "This script is under the GPL (GENERAL PUBLIC LICENSE)\n";
		print "http://www.gnu.org/copyleft/gpl.html\n\n";
		print "(C) 2004 by Tyler Davis <me\@tylerdavis.com>\n\n";
		print "Usage: shorewall_stats.pl <counter>\n\n";
		exit;
	   }

# get counter and hostname
$show   = $ARGV[0];
$host   = `$hostname`;

# get in/out statistics
$in	= `$shorewall show $show | head -n 7 | tail -1 | awk '{ print \$2 }'`;
$out	= `$shorewall show $show | head -n 8 | tail -1 | awk '{ print \$2 }'`;

#Convert data transferred to bytes
if ( rindex($in,"M") != "-1") {
	#Megabytes
	$in = ($in*1024*1024);
   } else {
	#Kilobytes
	$in = ($in*1024);
   }
if ( rindex($out,"M") != "-1") {
        #Megabytes
        $out = ($out*1024*1024);
   } else {
        #Kilobytes
        $out = ($out*1024);
   }

$uptime = `$uptime`;
$uptime =~ /up (.*?,.*?),/;
$up = $1;

# print out data in an mrtg friendly way
print "$in\n";
print "$out\n";
print "$up\n";
print "$host";
# END